/* A Bison parser, made by GNU Bison 2.5.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */


/* First part of user declarations.  */


/* Line 293 of lalr1.cc  */
#line 39 "Parser.tab.cc"


#include "Parser.tab.hh"

/* User implementation prologue.  */


/* Line 299 of lalr1.cc  */
#line 48 "Parser.tab.cc"
/* Unqualified %code blocks.  */

/* Line 300 of lalr1.cc  */
#line 120 "Parser.yy"


#include "Parser.hpp"
#include "Lexer.hpp"

#include "Atom.hpp"

int yylex(Lexer::semanticT* yylval, Lexer& l);
static Cell* operatorName(const Atom& a);




/* Line 300 of lalr1.cc  */
#line 67 "Parser.tab.cc"

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                               \
 do                                                                    \
   if (N)                                                              \
     {                                                                 \
       (Current).begin = YYRHSLOC (Rhs, 1).begin;                      \
       (Current).end   = YYRHSLOC (Rhs, N).end;                        \
     }                                                                 \
   else                                                                \
     {                                                                 \
       (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;        \
     }                                                                 \
 while (false)
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define yyerrok		(yyerrstatus_ = 0)
#define yyclearin	(yychar = yyempty_)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace yy {

/* Line 382 of lalr1.cc  */
#line 153 "Parser.tab.cc"

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  parser::parser (Parser& p_yyarg, Lexer& l_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      p (p_yyarg),
      l (l_yyarg)
  {
  }

  parser::~parser ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  parser::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
         default:
	  break;
      }
  }


  void
  parser::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif

  void
  parser::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
        case 3: /* "ATOM" */

/* Line 480 of lalr1.cc  */
#line 103 "Parser.yy"
	{
  delete (yyvaluep->atom);
};

/* Line 480 of lalr1.cc  */
#line 261 "Parser.tab.cc"
	break;
      case 4: /* "CELL" */

/* Line 480 of lalr1.cc  */
#line 103 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 272 "Parser.tab.cc"
	break;
      case 5: /* "OPERATOR" */

/* Line 480 of lalr1.cc  */
#line 103 "Parser.yy"
	{
  delete (yyvaluep->atom);
};

/* Line 480 of lalr1.cc  */
#line 283 "Parser.tab.cc"
	break;
      case 33: /* "innerValue" */

/* Line 480 of lalr1.cc  */
#line 103 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 294 "Parser.tab.cc"
	break;
      case 34: /* "value" */

/* Line 480 of lalr1.cc  */
#line 103 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 305 "Parser.tab.cc"
	break;
      case 35: /* "funcarglist" */

/* Line 480 of lalr1.cc  */
#line 107 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 316 "Parser.tab.cc"
	break;
      case 36: /* "comma_funcarglist" */

/* Line 480 of lalr1.cc  */
#line 107 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 327 "Parser.tab.cc"
	break;
      case 37: /* "def_funcarglist" */

/* Line 480 of lalr1.cc  */
#line 107 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 338 "Parser.tab.cc"
	break;
      case 38: /* "comma_argdef" */

/* Line 480 of lalr1.cc  */
#line 107 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 349 "Parser.tab.cc"
	break;
      case 39: /* "argdef" */

/* Line 480 of lalr1.cc  */
#line 107 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 360 "Parser.tab.cc"
	break;
      case 40: /* "member_list" */

/* Line 480 of lalr1.cc  */
#line 111 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 371 "Parser.tab.cc"
	break;
      case 41: /* "comma_memberlist" */

/* Line 480 of lalr1.cc  */
#line 111 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 382 "Parser.tab.cc"
	break;
      case 42: /* "memberdef" */

/* Line 480 of lalr1.cc  */
#line 111 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 393 "Parser.tab.cc"
	break;
      case 43: /* "super_list" */

/* Line 480 of lalr1.cc  */
#line 111 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 404 "Parser.tab.cc"
	break;
      case 44: /* "comma_superlist" */

/* Line 480 of lalr1.cc  */
#line 111 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 415 "Parser.tab.cc"
	break;
      case 45: /* "superdef" */

/* Line 480 of lalr1.cc  */
#line 111 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 426 "Parser.tab.cc"
	break;
      case 46: /* "actarglist" */

/* Line 480 of lalr1.cc  */
#line 115 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 437 "Parser.tab.cc"
	break;
      case 47: /* "actioncall" */

/* Line 480 of lalr1.cc  */
#line 115 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 448 "Parser.tab.cc"
	break;
      case 48: /* "def_actarglist" */

/* Line 480 of lalr1.cc  */
#line 115 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 459 "Parser.tab.cc"
	break;
      case 49: /* "actbodyStmt" */

/* Line 480 of lalr1.cc  */
#line 115 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 470 "Parser.tab.cc"
	break;
      case 50: /* "actbody" */

/* Line 480 of lalr1.cc  */
#line 115 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 481 "Parser.tab.cc"
	break;
      case 51: /* "lazySequence" */

/* Line 480 of lalr1.cc  */
#line 115 "Parser.yy"
	{
  delete (yyvaluep->list);
};

/* Line 480 of lalr1.cc  */
#line 492 "Parser.tab.cc"
	break;
      case 52: /* "declaration" */

/* Line 480 of lalr1.cc  */
#line 103 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 503 "Parser.tab.cc"
	break;
      case 53: /* "result" */

/* Line 480 of lalr1.cc  */
#line 103 "Parser.yy"
	{
  delete (yyvaluep->cell);
};

/* Line 480 of lalr1.cc  */
#line 514 "Parser.tab.cc"
	break;

	default:
	  break;
      }
  }

  void
  parser::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  inline bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::parse ()
  {
    /// Lookahead and lookahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the lookahead.
    semantic_type yylval;
    /// Location of the lookahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location_type yyerror_range[3];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    /* Read a lookahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, l);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yy_table_value_is_error_ (yyn))
	  goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Shift the lookahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted.  */
    yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 2:

/* Line 690 of lalr1.cc  */
#line 140 "Parser.yy"
    {
    (yyval.cell)=new Cell(*(yysemantic_stack_[(1) - (1)].atom));
    delete (yysemantic_stack_[(1) - (1)].atom); /* Bison discards the symbol for the above */
  }
    break;

  case 3:

/* Line 690 of lalr1.cc  */
#line 152 "Parser.yy"
    {
    (yyval.cell)=(yysemantic_stack_[(1) - (1)].cell);
  }
    break;

  case 4:

/* Line 690 of lalr1.cc  */
#line 157 "Parser.yy"
    {
    (yyval.cell)=(yysemantic_stack_[(1) - (1)].cell);
  }
    break;

  case 5:

/* Line 690 of lalr1.cc  */
#line 162 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_cast")), (yysemantic_stack_[(3) - (3)].cell), (yysemantic_stack_[(3) - (1)].cell), NULL));
  }
    break;

  case 6:

/* Line 690 of lalr1.cc  */
#line 171 "Parser.yy"
    {
    (yyval.cell)=(yysemantic_stack_[(1) - (1)].cell);
  }
    break;

  case 7:

/* Line 690 of lalr1.cc  */
#line 176 "Parser.yy"
    {
    (yyval.cell)=new Cell(new List((yysemantic_stack_[(3) - (2)].cell), (yysemantic_stack_[(3) - (3)].list)));
  }
    break;

  case 8:

/* Line 690 of lalr1.cc  */
#line 181 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_cast")), (yysemantic_stack_[(5) - (4)].cell),
      new Cell(new List((yysemantic_stack_[(5) - (2)].cell), (yysemantic_stack_[(5) - (5)].list))), NULL));
  }
    break;

  case 9:

/* Line 690 of lalr1.cc  */
#line 187 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_if")), (yysemantic_stack_[(6) - (2)].cell), (yysemantic_stack_[(6) - (3)].cell), (yysemantic_stack_[(6) - (6)].cell), NULL));
  }
    break;

  case 10:

/* Line 690 of lalr1.cc  */
#line 192 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(operatorName(*(yysemantic_stack_[(2) - (1)].atom)), (yysemantic_stack_[(2) - (2)].cell), NULL));
    delete (yysemantic_stack_[(2) - (1)].atom);
  }
    break;

  case 11:

/* Line 690 of lalr1.cc  */
#line 198 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(operatorName(*(yysemantic_stack_[(3) - (2)].atom)), (yysemantic_stack_[(3) - (1)].cell), (yysemantic_stack_[(3) - (3)].cell), NULL));
    delete (yysemantic_stack_[(3) - (2)].atom);
  }
    break;

  case 12:

/* Line 690 of lalr1.cc  */
#line 204 "Parser.yy"
    {
    (yyval.cell)=new Cell(new List(new Cell(Atom("!")), (yysemantic_stack_[(1) - (1)].list)));
  }
    break;

  case 13:

/* Line 690 of lalr1.cc  */
#line 209 "Parser.yy"
    {
    (yyval.cell)=new Cell(new List(new Cell(Atom("_sequence")), (yysemantic_stack_[(1) - (1)].list)));
  }
    break;

  case 14:

/* Line 690 of lalr1.cc  */
#line 218 "Parser.yy"
    {
    (yyval.list)=new List((yysemantic_stack_[(1) - (1)].cell));
  }
    break;

  case 15:

/* Line 690 of lalr1.cc  */
#line 222 "Parser.yy"
    {
    (yysemantic_stack_[(4) - (2)].list)->pushBack((yysemantic_stack_[(4) - (4)].cell));
    (yyval.list)=(yysemantic_stack_[(4) - (2)].list);
  }
    break;

  case 16:

/* Line 690 of lalr1.cc  */
#line 230 "Parser.yy"
    {
    (yyval.list)=new List((yysemantic_stack_[(1) - (1)].cell));
  }
    break;

  case 17:

/* Line 690 of lalr1.cc  */
#line 234 "Parser.yy"
    {
    (yyval.list)=(yysemantic_stack_[(3) - (1)].list);
    (yyval.list)->pushBack((yysemantic_stack_[(3) - (3)].cell));
  }
    break;

  case 18:

/* Line 690 of lalr1.cc  */
#line 242 "Parser.yy"
    {
    (yyval.cell)=new Cell(new List((yysemantic_stack_[(2) - (2)].cell)));
  }
    break;

  case 19:

/* Line 690 of lalr1.cc  */
#line 246 "Parser.yy"
    {
    (yysemantic_stack_[(4) - (2)].list)->pushBack((yysemantic_stack_[(4) - (4)].cell));
    (yyval.cell)=new Cell((yysemantic_stack_[(4) - (2)].list));
  }
    break;

  case 20:

/* Line 690 of lalr1.cc  */
#line 254 "Parser.yy"
    {
    (yyval.list)=new List((yysemantic_stack_[(1) - (1)].cell));
  }
    break;

  case 21:

/* Line 690 of lalr1.cc  */
#line 258 "Parser.yy"
    {
    (yysemantic_stack_[(3) - (1)].list)->pushBack((yysemantic_stack_[(3) - (3)].cell));
    (yyval.list)=(yysemantic_stack_[(3) - (1)].list);
  }
    break;

  case 22:

/* Line 690 of lalr1.cc  */
#line 266 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build((yysemantic_stack_[(3) - (2)].cell), (yysemantic_stack_[(3) - (3)].cell), NULL));
  }
    break;

  case 23:

/* Line 690 of lalr1.cc  */
#line 275 "Parser.yy"
    {
    (yyval.cell)=new Cell(new List((yysemantic_stack_[(2) - (2)].cell)));
  }
    break;

  case 24:

/* Line 690 of lalr1.cc  */
#line 279 "Parser.yy"
    {
    (yysemantic_stack_[(4) - (2)].list)->pushBack((yysemantic_stack_[(4) - (4)].cell));
    (yyval.cell)=new Cell((yysemantic_stack_[(4) - (2)].list));
  }
    break;

  case 25:

/* Line 690 of lalr1.cc  */
#line 287 "Parser.yy"
    {
    (yyval.list)=new List((yysemantic_stack_[(1) - (1)].cell));
  }
    break;

  case 26:

/* Line 690 of lalr1.cc  */
#line 291 "Parser.yy"
    {
    (yysemantic_stack_[(3) - (1)].list)->pushBack((yysemantic_stack_[(3) - (3)].cell));
    (yyval.list)=(yysemantic_stack_[(3) - (1)].list);
  }
    break;

  case 27:

/* Line 690 of lalr1.cc  */
#line 299 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build((yysemantic_stack_[(3) - (2)].cell), (yysemantic_stack_[(3) - (3)].cell), NULL));
  }
    break;

  case 28:

/* Line 690 of lalr1.cc  */
#line 306 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build((yysemantic_stack_[(2) - (2)].cell), NULL));
  }
    break;

  case 29:

/* Line 690 of lalr1.cc  */
#line 310 "Parser.yy"
    {
    (yysemantic_stack_[(4) - (2)].list)->pushBack((yysemantic_stack_[(4) - (4)].cell));
    (yyval.cell)=new Cell((yysemantic_stack_[(4) - (2)].list));
  }
    break;

  case 30:

/* Line 690 of lalr1.cc  */
#line 318 "Parser.yy"
    {
    (yyval.list)=new List((yysemantic_stack_[(1) - (1)].cell));
  }
    break;

  case 31:

/* Line 690 of lalr1.cc  */
#line 322 "Parser.yy"
    {
    (yysemantic_stack_[(3) - (1)].list)->pushBack((yysemantic_stack_[(3) - (3)].cell));
    (yyval.list)=(yysemantic_stack_[(3) - (1)].list);
  }
    break;

  case 32:

/* Line 690 of lalr1.cc  */
#line 331 "Parser.yy"
    {
    (yyval.cell)=new Cell(new List((yysemantic_stack_[(2) - (2)].cell)));
  }
    break;

  case 33:

/* Line 690 of lalr1.cc  */
#line 336 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build((yysemantic_stack_[(6) - (2)].cell), (yysemantic_stack_[(6) - (5)].cell), NULL));
  }
    break;

  case 34:

/* Line 690 of lalr1.cc  */
#line 345 "Parser.yy"
    {
    (yyval.list)=new List((yysemantic_stack_[(2) - (2)].cell));
  }
    break;

  case 35:

/* Line 690 of lalr1.cc  */
#line 349 "Parser.yy"
    {
    (yysemantic_stack_[(4) - (2)].list)->pushBack((yysemantic_stack_[(4) - (4)].cell));
    (yyval.list)=(yysemantic_stack_[(4) - (2)].list);
  }
    break;

  case 36:

/* Line 690 of lalr1.cc  */
#line 365 "Parser.yy"
    {
    (yyval.list)=new List((yysemantic_stack_[(3) - (1)].cell), (yysemantic_stack_[(3) - (2)].list));
  }
    break;

  case 37:

/* Line 690 of lalr1.cc  */
#line 370 "Parser.yy"
    {
    (yyval.list)=List::build(new Cell(Atom("_do")), (yysemantic_stack_[(3) - (2)].cell), NULL);
  }
    break;

  case 38:

/* Line 690 of lalr1.cc  */
#line 377 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build((yysemantic_stack_[(2) - (2)].cell), NULL));
  }
    break;

  case 39:

/* Line 690 of lalr1.cc  */
#line 381 "Parser.yy"
    {
    (yysemantic_stack_[(4) - (2)].list)->pushBack((yysemantic_stack_[(4) - (4)].cell));
    (yyval.cell)=new Cell((yysemantic_stack_[(4) - (2)].list));
  }
    break;

  case 40:

/* Line 690 of lalr1.cc  */
#line 389 "Parser.yy"
    {
    (yyval.list)=(yysemantic_stack_[(1) - (1)].list);
  }
    break;

  case 41:

/* Line 690 of lalr1.cc  */
#line 393 "Parser.yy"
    {
    (yyval.list)=List::build(new Cell(Atom("_constant")), (yysemantic_stack_[(4) - (2)].cell), (yysemantic_stack_[(4) - (3)].cell), NULL);
  }
    break;

  case 42:

/* Line 690 of lalr1.cc  */
#line 400 "Parser.yy"
    {
    (yyval.list)=new List(new Cell((yysemantic_stack_[(1) - (1)].list)));
  }
    break;

  case 43:

/* Line 690 of lalr1.cc  */
#line 404 "Parser.yy"
    {
    (yysemantic_stack_[(2) - (1)].list)->pushBack(new Cell((yysemantic_stack_[(2) - (2)].list)));
    (yyval.list)=(yysemantic_stack_[(2) - (1)].list);
  }
    break;

  case 44:

/* Line 690 of lalr1.cc  */
#line 412 "Parser.yy"
    {
    (yyval.list)=List::build((yysemantic_stack_[(3) - (1)].cell), (yysemantic_stack_[(3) - (3)].cell), NULL);
  }
    break;

  case 45:

/* Line 690 of lalr1.cc  */
#line 416 "Parser.yy"
    {
    (yysemantic_stack_[(3) - (1)].list)->pushBack((yysemantic_stack_[(3) - (3)].cell));
    (yyval.list)=(yysemantic_stack_[(3) - (1)].list);
  }
    break;

  case 46:

/* Line 690 of lalr1.cc  */
#line 427 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_constant")), (yysemantic_stack_[(4) - (2)].cell), (yysemantic_stack_[(4) - (3)].cell), NULL));
  }
    break;

  case 47:

/* Line 690 of lalr1.cc  */
#line 432 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_function")), (yysemantic_stack_[(6) - (2)].cell), (yysemantic_stack_[(6) - (3)].cell), (yysemantic_stack_[(6) - (5)].cell), NULL));
  }
    break;

  case 48:

/* Line 690 of lalr1.cc  */
#line 437 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_class")), (yysemantic_stack_[(4) - (2)].cell),
      new Cell(List::build()), (yysemantic_stack_[(4) - (3)].cell), NULL));
  }
    break;

  case 49:

/* Line 690 of lalr1.cc  */
#line 443 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_class")), (yysemantic_stack_[(4) - (2)].cell),
      (yysemantic_stack_[(4) - (3)].cell), new Cell(List::build()), NULL));
  }
    break;

  case 50:

/* Line 690 of lalr1.cc  */
#line 449 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_class")), (yysemantic_stack_[(7) - (2)].cell), (yysemantic_stack_[(7) - (3)].cell), (yysemantic_stack_[(7) - (6)].cell), NULL));
  }
    break;

  case 51:

/* Line 690 of lalr1.cc  */
#line 454 "Parser.yy"
    {
    l.defineOperator((yysemantic_stack_[(6) - (1)].cell)->getAtom());
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_function")),
      operatorName((yysemantic_stack_[(6) - (1)].cell)->getAtom()),
      new Cell(new List(new Cell(List::build((yysemantic_stack_[(6) - (2)].cell), (yysemantic_stack_[(6) - (3)].cell), NULL)))),
      (yysemantic_stack_[(6) - (5)].cell), NULL));
    delete (yysemantic_stack_[(6) - (1)].cell);
  }
    break;

  case 52:

/* Line 690 of lalr1.cc  */
#line 464 "Parser.yy"
    {
    l.defineOperator((yysemantic_stack_[(8) - (3)].cell)->getAtom());
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_function")),
      operatorName((yysemantic_stack_[(8) - (3)].cell)->getAtom()),
      new Cell(List::build(
        new Cell(List::build((yysemantic_stack_[(8) - (1)].cell), (yysemantic_stack_[(8) - (2)].cell), NULL)),
        new Cell(List::build((yysemantic_stack_[(8) - (4)].cell), (yysemantic_stack_[(8) - (5)].cell), NULL)),
        NULL)),
      (yysemantic_stack_[(8) - (7)].cell), NULL));
    delete (yysemantic_stack_[(8) - (3)].cell);
  }
    break;

  case 53:

/* Line 690 of lalr1.cc  */
#line 486 "Parser.yy"
    {
    (yyval.cell)=new Cell(List::build(new Cell(Atom("_action")), (yysemantic_stack_[(6) - (1)].cell),
      (yysemantic_stack_[(6) - (3)].cell), new Cell((yysemantic_stack_[(6) - (5)].list)), NULL));
  }
    break;

  case 54:

/* Line 690 of lalr1.cc  */
#line 494 "Parser.yy"
    {
    (yyval.cell)=(yysemantic_stack_[(1) - (1)].cell);
  }
    break;

  case 55:

/* Line 690 of lalr1.cc  */
#line 498 "Parser.yy"
    {
    (yyval.cell)=(yysemantic_stack_[(2) - (1)].cell);
  }
    break;

  case 56:

/* Line 690 of lalr1.cc  */
#line 502 "Parser.yy"
    {
    (yyval.cell)=new Cell((yysemantic_stack_[(2) - (1)].list));
  }
    break;

  case 57:

/* Line 690 of lalr1.cc  */
#line 506 "Parser.yy"
    {
    // Empty value signals EOF
    (yyval.cell)=NULL;
  }
    break;

  case 58:

/* Line 690 of lalr1.cc  */
#line 514 "Parser.yy"
    {
    p.setValue((yysemantic_stack_[(1) - (1)].cell));
    YYACCEPT;
  }
    break;



/* Line 690 of lalr1.cc  */
#line 1266 "Parser.tab.cc"
	default:
          break;
      }
    /* User semantic actions sometimes alter yychar, and that requires
       that yytoken be updated with the new translation.  We take the
       approach of translating immediately before every use of yytoken.
       One alternative is translating here after every semantic action,
       but that translation would be missed if the semantic action
       invokes YYABORT, YYACCEPT, or YYERROR immediately after altering
       yychar.  In the case of YYABORT or YYACCEPT, an incorrect
       destructor might then be invoked immediately.  In the case of
       YYERROR, subsequent parser actions might lead to an incorrect
       destructor call or verbose syntax error message before the
       lookahead is translated.  */
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* Make sure we have latest lookahead translation.  See comments at
       user semantic actions for why this is necessary.  */
    yytoken = yytranslate_ (yychar);

    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	if (yychar == yyempty_)
	  yytoken = yyempty_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[1] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[1] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (!yy_pact_value_is_default_ (yyn))
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[1] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    yyerror_range[2] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the lookahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyempty_)
      {
        /* Make sure we have latest lookahead translation.  See comments
           at user semantic actions for why this is necessary.  */
        yytoken = yytranslate_ (yychar);
        yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval,
                     &yylloc);
      }

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (int yystate, int yytoken)
  {
    std::string yyres;
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yytoken) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yychar.
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (yytoken != yyempty_)
      {
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            /* Stay within bounds of both yycheck and yytname.  */
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = 0;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char parser::yypact_ninf_ = -46;
  const short int
  parser::yypact_[] =
  {
       111,   -46,   -46,   -46,   137,    19,    19,    19,    19,   137,
     137,    51,    11,    33,   -22,     5,   -46,   -46,    60,    38,
      15,   -46,    22,    89,    64,   137,    47,    41,   137,    43,
      19,    82,   137,    19,   137,   -46,   -46,   137,   -46,   137,
      19,    15,   -46,    97,   104,   115,   121,   102,    78,    95,
      -5,   -46,   100,    -9,    97,   109,     9,   -46,    15,   -46,
      15,    15,    15,    -7,    71,    19,     7,   116,   137,    19,
      72,    76,    19,    90,   126,   -46,   -46,   144,   -46,   130,
     137,   137,    91,   127,    79,   137,    19,   137,   -46,    19,
      97,    97,   107,   134,   115,   115,    19,   121,   121,   143,
     137,    15,    15,    97,    19,    38,   -46,   -46,    34,   110,
     145,    15,   -46,   -46,   -46,   -46,   155,   -46,   -46,   -46,
     -46,   -46,   135,    15,   -46,   137,   -46,   -46,   -46,   137,
      19,   -46,   119,   120,   139,   -46,   -46,   -46
  };

  /* YYDEFACT[S] -- default reduction number in state S.  Performed when
     YYTABLE doesn't specify something else to do.  Zero means the
     default is an error.  */
  const unsigned char
  parser::yydefact_[] =
  {
         0,    57,     2,     4,     0,     0,     0,     0,     0,     0,
       0,     3,     6,     0,    12,    13,    54,    58,     0,     3,
      10,    12,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    55,    56,     0,     1,     0,
       0,    14,     7,     0,     0,     0,     0,     0,     0,     0,
       0,    37,    16,     0,     0,     0,     0,    36,    11,     5,
      44,    45,    16,     0,     0,     0,     0,    20,     0,     0,
       0,    28,     0,     0,    25,    48,    49,     0,    46,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     8,     0,
       0,     0,     0,    32,     0,     0,     0,     0,     0,     0,
       0,    35,    17,     0,     0,     0,    40,    42,     0,     0,
       0,    15,    22,    19,    21,    47,     0,    29,    31,    27,
      24,    26,     0,     9,    39,     0,    53,    43,    51,     0,
       0,    50,     0,     0,     0,    41,    52,    33
  };

  /* YYPGOTO[NTERM-NUM].  */
  const signed char
  parser::yypgoto_[] =
  {
       -46,     0,   -46,    10,   101,   125,   -46,   112,   -45,    68,
     -46,    52,   -46,   -46,    57,   -46,     1,   -46,    61,   -46,
     -46,   -46,   -46,   -46
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const signed char
  parser::yydefgoto_[] =
  {
        -1,    19,    12,    41,    42,    53,    44,    66,    67,    47,
      73,    74,    48,    70,    71,    31,    21,    55,   107,   108,
      15,    16,    17,    18
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If YYTABLE_NINF_, syntax error.  */
  const signed char parser::yytable_ninf_ = -39;
  const short int
  parser::yytable_[] =
  {
        11,    14,    80,    36,    87,    22,    23,    24,    25,    83,
      13,    30,     2,    81,    20,    81,    32,    79,    90,    26,
      27,    34,     2,    33,    85,     2,     3,     4,     5,    91,
      56,    37,    39,    59,    40,    49,    50,     2,    52,     9,
      64,    34,    58,    10,    60,   113,   114,    61,   104,    62,
       2,     3,     4,     5,     2,    10,    86,    28,   124,    34,
      38,   126,    54,    35,     9,    89,    51,    34,    10,    93,
      28,    29,    96,    34,     2,     3,     4,     5,    92,    45,
      46,    39,     2,    94,   105,   106,   110,   -30,     9,   112,
     101,   102,    10,   104,    95,   109,   119,   111,   -30,    43,
      10,    97,   103,    65,   125,    76,    77,    57,   105,   106,
     123,     1,    98,    91,     2,     3,     4,     5,     6,    68,
       7,    34,    78,    69,     8,   -34,    34,    72,     9,    75,
     134,   -18,    10,    34,   115,   132,    34,   128,    84,   133,
       2,     3,     4,     5,   135,    34,    34,   136,   100,   120,
     121,   117,   118,   -23,     9,    99,   -38,   116,    10,    46,
     129,   130,   131,   137,    63,    88,    82,   122,     0,   127
  };

  /* YYCHECK.  */
  const short int
  parser::yycheck_[] =
  {
         0,     0,    11,    25,    11,     5,     6,     7,     8,    54,
       0,    11,     3,    22,     4,    22,     5,    22,    11,     9,
      10,    26,     3,    12,    15,     3,     4,     5,     6,    22,
      30,    26,    10,    33,    12,    25,    26,     3,    28,    17,
      40,    26,    32,    21,    34,    90,    91,    37,    14,    39,
       3,     4,     5,     6,     3,    21,    56,    19,   103,    26,
       0,    27,    19,    30,    17,    65,    25,    26,    21,    69,
      19,    20,    72,    26,     3,     4,     5,     6,    68,    15,
      16,    10,     3,    11,    84,    84,    86,    11,    17,    89,
      80,    81,    21,    14,    22,    85,    96,    87,    22,    10,
      21,    11,    11,     6,   104,    27,    28,    25,   108,   108,
     100,     0,    22,    22,     3,     4,     5,     6,     7,    15,
       9,    26,    27,     8,    13,    25,    26,     6,    17,    27,
     130,    15,    21,    26,    27,   125,    26,    27,    29,   129,
       3,     4,     5,     6,    25,    26,    26,    27,    18,    97,
      98,    94,    95,    27,    17,    11,    29,    23,    21,    16,
      15,     6,    27,    24,    39,    64,    54,    99,    -1,   108
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  parser::yystos_[] =
  {
         0,     0,     3,     4,     5,     6,     7,     9,    13,    17,
      21,    32,    33,    34,    47,    51,    52,    53,    54,    32,
      34,    47,    32,    32,    32,    32,    34,    34,    19,    20,
      32,    46,     5,    12,    26,    30,    25,    26,     0,    10,
      12,    34,    35,    10,    37,    15,    16,    40,    43,    34,
      34,    25,    34,    36,    19,    48,    32,    25,    34,    32,
      34,    34,    34,    36,    32,     6,    38,    39,    15,     8,
      44,    45,     6,    41,    42,    27,    27,    28,    27,    22,
      11,    22,    38,    39,    29,    15,    32,    11,    35,    32,
      11,    22,    34,    32,    11,    22,    32,    11,    22,    11,
      18,    34,    34,    11,    14,    32,    47,    49,    50,    34,
      32,    34,    32,    39,    39,    27,    23,    45,    45,    32,
      42,    42,    40,    34,    39,    32,    27,    49,    27,    15,
       6,    27,    34,    34,    32,    25,    27,    24
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  parser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    44,    40,    41,    33,    38,    46,    59,    58,
      63
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  parser::yyr1_[] =
  {
         0,    31,    32,    33,    33,    33,    34,    34,    34,    34,
      34,    34,    34,    34,    35,    35,    36,    36,    37,    37,
      38,    38,    39,    40,    40,    41,    41,    42,    43,    43,
      44,    44,    45,    45,    46,    46,    47,    47,    48,    48,
      49,    49,    50,    50,    51,    51,    52,    52,    52,    52,
      52,    52,    52,    52,    53,    53,    53,    53,    54
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  parser::yyr2_[] =
  {
         0,     2,     1,     1,     1,     3,     1,     3,     5,     6,
       2,     3,     1,     1,     1,     4,     1,     3,     2,     4,
       1,     3,     3,     2,     4,     1,     3,     3,     2,     4,
       1,     3,     2,     6,     2,     4,     3,     3,     2,     4,
       1,     4,     1,     2,     3,     3,     4,     6,     4,     4,
       7,     6,     8,     6,     1,     2,     2,     1,     1
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const parser::yytname_[] =
  {
    "EOF_SYMBOL", "error", "$undefined", "ATOM", "CELL", "OPERATOR", "DER",
  "DDER", "EIN", "EEIN", "VON", "UND", "ALS", "SSEI", "SEI", "IST", "HAT",
  "FUER", "SONST", "MIT", "BEDEUTET", "MACHE", "','", "'('", "')'", "'!'",
  "'&'", "'.'", "';'", "':'", "'?'", "$accept", "name", "innerValue",
  "value", "funcarglist", "comma_funcarglist", "def_funcarglist",
  "comma_argdef", "argdef", "member_list", "comma_memberlist", "memberdef",
  "super_list", "comma_superlist", "superdef", "actarglist", "actioncall",
  "def_actarglist", "actbodyStmt", "actbody", "lazySequence",
  "declaration", "result", "start", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const parser::rhs_number_type
  parser::yyrhs_[] =
  {
        54,     0,    -1,     3,    -1,    32,    -1,     4,    -1,    33,
      12,    32,    -1,    33,    -1,     6,    32,    35,    -1,     6,
      32,    12,    32,    35,    -1,    17,    34,    34,    22,    18,
      34,    -1,     5,    34,    -1,    33,     5,    34,    -1,    47,
      -1,    51,    -1,    34,    -1,    10,    36,    11,    34,    -1,
      34,    -1,    36,    22,    34,    -1,    10,    39,    -1,    10,
      38,    11,    39,    -1,    39,    -1,    38,    22,    39,    -1,
       6,    32,    32,    -1,    16,    42,    -1,    16,    41,    11,
      42,    -1,    42,    -1,    41,    22,    42,    -1,     6,    32,
      32,    -1,    15,    45,    -1,    15,    44,    11,    45,    -1,
      45,    -1,    44,    22,    45,    -1,     8,    32,    -1,     8,
      32,    23,     6,    32,    24,    -1,    19,    34,    -1,    19,
      36,    11,    34,    -1,    32,    46,    25,    -1,    21,    34,
      25,    -1,    19,    39,    -1,    19,    38,    11,    39,    -1,
      47,    -1,    14,    32,    34,    25,    -1,    49,    -1,    50,
      49,    -1,    34,    26,    34,    -1,    51,    26,    34,    -1,
      13,    32,    34,    27,    -1,     7,    32,    37,    15,    34,
      27,    -1,     9,    32,    40,    27,    -1,     9,    32,    43,
      27,    -1,     9,    32,    43,    28,    11,    40,    27,    -1,
      32,    32,    32,    15,    34,    27,    -1,    32,    32,    32,
      32,    32,    15,    34,    27,    -1,    32,    20,    48,    29,
      50,    27,    -1,    52,    -1,    34,    30,    -1,    47,    25,
      -1,     0,    -1,    53,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned char
  parser::yyprhs_[] =
  {
         0,     0,     3,     5,     7,     9,    13,    15,    19,    25,
      32,    35,    39,    41,    43,    45,    50,    52,    56,    59,
      64,    66,    70,    74,    77,    82,    84,    88,    92,    95,
     100,   102,   106,   109,   116,   119,   124,   128,   132,   135,
     140,   142,   147,   149,   152,   156,   160,   165,   172,   177,
     182,   190,   197,   206,   213,   215,   218,   221,   223
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned short int
  parser::yyrline_[] =
  {
         0,   139,   139,   151,   156,   161,   170,   175,   180,   186,
     191,   197,   203,   208,   217,   221,   229,   233,   241,   245,
     253,   257,   265,   274,   278,   286,   290,   298,   305,   309,
     317,   321,   330,   335,   344,   348,   364,   369,   376,   380,
     388,   392,   399,   403,   411,   415,   426,   431,   436,   442,
     448,   453,   463,   485,   493,   497,   501,   505,   513
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  parser::token_number_type
  parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    25,     2,     2,     2,     2,    26,     2,
      23,    24,     2,     2,    22,     2,    27,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    29,    28,
       2,     2,     2,    30,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int parser::yyeof_ = 0;
  const int parser::yylast_ = 169;
  const int parser::yynnts_ = 24;
  const int parser::yyempty_ = -2;
  const int parser::yyfinal_ = 38;
  const int parser::yyterror_ = 1;
  const int parser::yyerrcode_ = 256;
  const int parser::yyntokens_ = 31;

  const unsigned int parser::yyuser_token_number_max_ = 276;
  const parser::token_number_type parser::yyundef_token_ = 2;


} // yy

/* Line 1136 of lalr1.cc  */
#line 1868 "Parser.tab.cc"


/* Line 1138 of lalr1.cc  */
#line 521 "Parser.yy"


#include <iostream>
#include <string>

// Redirect yylex
int yylex(Lexer::semanticT* yylval, Lexer& l)
{
  const int token(l.yylex(*yylval));
  //std::cout << token << " " << (char)token << std::endl;
  return token;
}

// Build name of operator-function
Cell* operatorName(const Atom& a)
{
  return new Cell(Atom("_operator_"+a.str()));
}

void yy::parser::error(const location_type& loc, const std::string& msg)
{
  std::cerr << "Parse error: " << msg << std::endl;
}

