/*

    Lispel, typed German language Lisp.
    Copyright (C) 2008  Daniel Kraft <d@domob.eu>
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef ELLIB_ELLIB_HPP
#define ELLIB_ELLIB_HPP

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

namespace lispel
{
namespace ellisp
{
  class Runtime;
}
using namespace ellisp;
namespace ellib
{

/**
 * Register the whole runtime library with a Runtime object.
 * @param rt The runtime object to register with
 */
void registerLibrary(Runtime& rt);

} // namespace ellib
} // namespace lispel

#endif // Header-guard
