#!/bin/sh
# Run the example programs through depel

programs="hello factorial countdown perfect vectors rot13 heron"

temp=`mktemp`

for i in $programs
do
  echo "Running $i..."
  echo >$temp
  if test -e $i.in
  then
    depel $i.dpl >$temp <$i.in
  else
    depel $i.dpl >$temp
  fi
  if ! cmp $i.out $temp
  then
    echo "  Error in output:"
    diff -u $i.out $temp
    exit 1
  fi
done

rm -f $temp
